Index: src/mlx/rpc.py
===================================================================
--- src/mlx/rpc.py	(revision 769)
+++ src/mlx/rpc.py	(revision 745)
@@ -125,25 +125,4 @@
 #---------------------------------------------------------------------------------------
 
-class Registration(object):
-    """Data for registration."""
-    def __init__(self, surName, firstName, nameOrder,
-                 yearOfBirth, emailAddress, emailAddressPublic,
-                 vatsimID, ivaoID, phoneNumber, nationality, password):
-        """Construct the registration data."""
-        self.surName = surName
-        self.firstName = firstName
-        self.nameOrder = nameOrder
-        self.yearOfBirth = yearOfBirth
-        self.emailAddress = emailAddress
-        self.emailAddressPublic = 1 if emailAddressPublic is True else \
-          0 if emailAddressPublic is False else emailAddressPublic
-        self.vatsimID = "" if vatsimID is None else vatsimID
-        self.ivaoID = "" if ivaoID is None else ivaoID
-        self.phoneNumber = phoneNumber
-        self.nationality = nationality
-        self.password = password
-
-#---------------------------------------------------------------------------------------
-
 class RPCException(Exception):
     """An exception thrown by RPC operations."""
@@ -176,7 +155,4 @@
     RESULT_DATABASE_ERROR = 3
 
-    # Result code: invalid data
-    RESULT_INVALID_DATA = 4
-
     # Result code: the flight does not exist
     RESULT_FLIGHT_NOT_EXISTS = 101
@@ -184,7 +160,4 @@
     # Result code: the flight has already been reported.
     RESULT_FLIGHT_ALREADY_REPORTED = 102
-
-    # Result code: a user with the given e-mail address already exists
-    RESULT_EMAIL_ALREADY_REGISTERED = 103
 
     def __init__(self, getCredentialsFn):
@@ -216,15 +189,4 @@
         self._sessionID = None
 
-    def register(self, registrationData):
-        """Register with the given data.
-
-        Returns a tuple of:
-        - the error code,
-        - the PID if there is no error."""
-        reply = Reply(self._server.register(registrationData))
-
-        return (reply.result,
-                reply.value["pid"] if reply.result==Client.RESULT_OK else None)
-
     def login(self):
         """Login using the given previously set credentials.
@@ -232,5 +194,5 @@
         The session ID is stored in the object and used for later calls.
 
-        Returns the name of the pilot on success, or None on error."""
+        Returns a boolean indicating if login has succeeded."""
         self._sessionID = None
 
@@ -239,5 +201,5 @@
             self._loginCount += 1
             self._sessionID = reply.value["sessionID"]
-            return (reply.value["name"], reply.value["rank"])
+            return reply.value["name"]
         else:
             return None
@@ -256,11 +218,4 @@
 
         return flights
-
-    def getEntryExamStatus(self):
-        """Get the status of the exams needed for joining MAVA."""
-        value = self._performCall(lambda sessionID:
-                                  self._server.getEntryExamStatus(sessionID))
-        return (value["entryExamPassed"], value["entryExamLink"],
-                value["checkFlightStatus"], value["madeFO"])
 
     def getFleet(self):
@@ -292,9 +247,4 @@
         self._performCall(lambda sessionID:
                           self._server.updateOnlineACARS(sessionID, acars))
-
-    def setCheckFlightPassed(self, type):
-        """Mark the check flight of the user passed with the given type."""
-        self._performCall(lambda sessionID:
-                          self._server.setCheckFlightPassed(sessionID, type))
 
     def _performCall(self, callFn, acceptResults = []):
Index: src/mlx/update.py
===================================================================
--- src/mlx/update.py	(revision 781)
+++ src/mlx/update.py	(revision 681)
@@ -297,28 +297,4 @@
 #------------------------------------------------------------------------------
 
-def removeFiles(directory, listener, removed, count):
-    """Remove the given files."""
-    toremoveDir = None
-    
-    listener.startRemoving()
-
-    removed.sort(reverse = True)
-    for path in removed:
-        removePath = createLocalPath(directory, path)
-        removeFile(toremoveDir, directory, removePath)
-
-        removeDirectory = os.path.dirname(removePath)
-        try:
-            os.removedirs(removeDirectory)
-        except:
-            pass
-
-        count += 1
-        listener.removed(path, count)
-
-    return count
-
-#------------------------------------------------------------------------------
-
 def updateFiles(directory, updateURL, listener,
                 manifest, modifiedAndNew, removed, localRemoved):
@@ -338,9 +314,4 @@
         updateURL += "/" + os.name
 
-        removeCount = 0
-        if localRemoved:
-            removeCount = removeFiles(directory, listener,
-                                      localRemoved, removeCount)
-        
         for (path, size, sum) in modifiedAndNew:
             targetFile = createLocalPath(directory, path)
@@ -375,6 +346,21 @@
             count += 1
             listener.renamed(path, count)
-
-        removeFiles(directory, listener, removed, removeCount)
+        
+        listener.startRemoving()
+        count = 0
+        removed += localRemoved
+        removed.sort(reverse = True)
+        for path in removed:            
+            removePath = createLocalPath(directory, path)
+            removeFile(toremoveDir, directory, removePath)
+
+            removeDirectory = os.path.dirname(removePath)
+            try:
+                os.removedirs(removeDirectory)
+            except:
+                pass
+
+            count += 1
+            listener.removed(path, count)
 
         listener.writingManifest()
Index: src/mlx/util.py
===================================================================
--- src/mlx/util.py	(revision 401)
+++ src/mlx/util.py	(revision 784)
@@ -170,6 +170,13 @@
 
 _utf8decoder = codecs.getdecoder("utf-8")
+_latin2decoder = codecs.getdecoder("iso8859-2")
 
 def utf2unicode(text):
     """Convert the given text from UTF-8 encoding to unicode."""
-    return unicode(_utf8decoder(text)[0])
+    try:
+        return unicode(_utf8decoder(text)[0])
+    except:
+        try:
+            return unicode(_latin2decoder(text)[0])
+        except:
+            return unicode(list(text))
Index: src/mlx/web.py
===================================================================
--- src/mlx/web.py	(revision 771)
+++ src/mlx/web.py	(revision 746)
@@ -2,5 +2,4 @@
 import const
 import util
-from rpc import Registration
 import rpc
 import rpccommon
@@ -91,7 +90,4 @@
                       const.AIRCRAFT_B462  : "146" }
 
-    checkFlightTypes = [ const.AIRCRAFT_B736, const.AIRCRAFT_B737,
-                         const.AIRCRAFT_B738, const.AIRCRAFT_DH8D ]
-
     @staticmethod
     def getDateTime(date, time):
@@ -99,36 +95,4 @@
         return datetime.datetime.strptime(date + " " + time,
                                           "%Y-%m-%d %H:%M:%S")
-
-    @staticmethod
-    def forCheckFlight(aircraftType):
-        """Create a booked flight for a check flight with the given aircraft
-        type."""
-        flight = BookedFlight()
-
-        flight.departureICAO = "LHBP"
-        flight.arrivalICAO = "LHBP"
-
-        flight.aircraftType = aircraftType
-        flight.aircraftTypeName = BookedFlight.TYPE2TYPECODE[aircraftType]
-
-        # FIXME: perhaps find one for the type
-        flight.tailNumber = "HA-CHK"
-        flight.callsign = "HA-CHK"
-
-        flight.numPassengers = 0
-        flight.numCrew = 2
-        flight.bagWeight = 0
-        flight.cargoWeight = 0
-        flight.mailWeight = 0
-        flight.route = "DCT"
-
-        t = datetime.datetime.now() + datetime.timedelta(minutes = 20)
-        flight.departureTime = datetime.datetime(t.year, t.month, t.day,
-                                                 t.hour, t.minute)
-        t = flight.departureTime + datetime.timedelta(minutes = 30)
-        flight.arrivalTime = datetime.datetime(t.year, t.month, t.day,
-                                               t.hour, t.minute)
-
-        return flight
 
     def __init__(self, id = None):
@@ -659,40 +623,9 @@
 #------------------------------------------------------------------------------
 
-class Register(RPCRequest):
-    """A registration request."""
-    def __init__(self, client, callback, registrationData):
-        """Construct the request."""
-        super(Register, self).__init__(client, callback)
-        self._registrationData = registrationData
-
-    def run(self):
-        """Perform the registration."""
-
-        registrationData = self._registrationData
-
-        (resultCode, pilotID) = self._client.register(registrationData)
-        result = Result()
-        result.registered = resultCode==rpc.Client.RESULT_OK
-        if result.registered:
-            result.pilotID = pilotID
-
-            self._client.setCredentials(pilotID, registrationData.password)
-            LoginRPC.setupLoginResult(result, self._client, pilotID,
-                                      registrationData.password)
-
-        result.invalidData = \
-          resultCode==rpc.Client.RESULT_INVALID_DATA
-        result.emailAlreadyRegistered = \
-          resultCode==rpc.Client.RESULT_EMAIL_ALREADY_REGISTERED
-
-        return result
-
-#------------------------------------------------------------------------------
-
 class Login(Request):
     """A login request."""
     iso88592decoder = codecs.getdecoder("iso-8859-2")
 
-    def __init__(self, callback, pilotID, password):
+    def __init__(self, callback, pilotID, password, entranceExam):
         """Construct the login request with the given pilot ID and
         password."""
@@ -701,4 +634,5 @@
         self._pilotID = pilotID
         self._password = password
+        self._entranceExam = entranceExam
 
     def run(self):
@@ -712,29 +646,43 @@
         password = md5.hexdigest()
 
-        url = MAVA_BASE_URL + "/leker2.php?pid=%s&psw=%s" %  (pilotID, password)
+        if self._entranceExam:
+            url = MAVA_BASE_URL + "/ellenorzo/getflightplan.php?pid=%s" % \
+                  (pilotID,)
+        else:
+            url = MAVA_BASE_URL + "/leker2.php?pid=%s&psw=%s" % \
+                  (pilotID, password)
 
         result = Result()
+        result.entranceExam = self._entranceExam
 
         f = urllib2.urlopen(url, timeout = 10.0)
 
         status = readline(f)
-        result.loggedIn = status == ".OK."
+        if self._entranceExam:
+            result.loggedIn = status != "#NOEXAM"
+        else:
+            result.loggedIn = status == ".OK."
 
         if result.loggedIn:
             result.pilotID = self._pilotID
             result.password = self._password
-            result.rank = "FO"
             result.flights = []
-
-            result.pilotName = self.iso88592decoder(readline(f))[0]
-            result.exams = readline(f)
-
-            while True:
-                line = readline(f)
-                if not line or line == "#ENDPIREP": break
-
-                flight = BookedFlight(line)
-                flight.readFromWeb(f)
-                result.flights.append(flight)
+            # FIXME: this may not be the correct behaviour
+            # for an entrance exam, but the website returns
+            # an error
+            if self._entranceExam:
+                result.pilotName = result.pilotID
+                result.exams = ""
+            else:
+                result.pilotName = self.iso88592decoder(readline(f))[0]
+                result.exams = readline(f)
+
+                while True:
+                    line = readline(f)
+                    if not line or line == "#ENDPIREP": break
+
+                    flight = BookedFlight(line)
+                    flight.readFromWeb(f)
+                    result.flights.append(flight)
 
             result.flights.sort(cmp = lambda flight1, flight2:
@@ -750,25 +698,5 @@
 class LoginRPC(RPCRequest):
     """An RPC-based login request."""
-    @staticmethod
-    def setupLoginResult(result, client, pilotID, password):
-        """Setup the login result with the given client, pilot ID and
-        password."""
-        loginResult = client.login()
-        result.loggedIn = loginResult is not None
-        if result.loggedIn:
-            result.pilotID = pilotID
-            result.pilotName = loginResult[0]
-            result.rank = loginResult[1]
-            result.password = password
-            result.flights = client.getFlights()
-            if result.rank=="STU":
-                reply = client.getEntryExamStatus()
-                result.entryExamPassed = reply[0]
-                result.entryExamLink = reply[1]
-                result.checkFlightStatus = reply[2]
-                if reply[3]:
-                    result.rank = "FO"
-
-    def __init__(self, client, callback, pilotID, password):
+    def __init__(self, client, callback, pilotID, password, entranceExam):
         """Construct the login request with the given pilot ID and
         password."""
@@ -777,33 +705,20 @@
         self._pilotID = pilotID
         self._password = password
+        self._entranceExam = entranceExam
 
     def run(self):
         """Perform the login request."""
         result = Result()
+        # FIXME: handle the entrance exam case
+        result.entranceExam = self._entranceExam
 
         self._client.setCredentials(self._pilotID, self._password)
-        LoginRPC.setupLoginResult(result, self._client,
-                                  self._pilotID, self._password)
-
-        return result
-
-#------------------------------------------------------------------------------
-
-class GetEntryExamStatus(RPCRequest):
-    """A request to get the entry exam status."""
-    def __init__(self, client, callback):
-        """Construct the request."""
-        super(GetEntryExamStatus, self).__init__(client, callback)
-
-    def run(self):
-        """Perform the query."""
-        result = Result()
-
-        reply = self._client.getEntryExamStatus()
-
-        result.entryExamPassed = reply[0]
-        result.entryExamLink = reply[1]
-        result.checkFlightStatus = reply[2]
-        result.madeFO = reply[3]
+        pilotName = self._client.login()
+        result.loggedIn = pilotName is not None
+        if result.loggedIn:
+            result.pilotID = self._pilotID
+            result.pilotName = pilotName
+            result.password = self._password
+            result.flights = self._client.getFlights()
 
         return result
@@ -1201,19 +1116,4 @@
 #------------------------------------------------------------------------------
 
-class SetCheckFlightPassed(RPCRequest):
-    """A request to mark the user as one having passed the check flight."""
-    def __init__(self, client, callback, aircraftType):
-        """Construct the request for the given type."""
-        super(SetCheckFlightPassed, self).__init__(client, callback)
-        self._aircraftType = aircraftType
-
-    def run(self):
-        """Perform the update."""
-        aircraftType = BookedFlight.TYPE2TYPECODE[self._aircraftType]
-        self._client.setCheckFlightPassed(aircraftType)
-        return Result()
-
-#------------------------------------------------------------------------------
-
 class Handler(threading.Thread):
     """The handler for the web services.
@@ -1234,19 +1134,12 @@
             self._rpcClient.setCredentials(config.pilotID, config.password)
 
-    def register(self, callback, registrationData):
-        """Enqueue a registration request."""
-        self._addRequest(Register(self._rpcClient, callback, registrationData))
-
-    def login(self, callback, pilotID, password):
+    def login(self, callback, pilotID, password, entranceExam = False):
         """Enqueue a login request."""
         request = \
-          LoginRPC(self._rpcClient, callback, pilotID, password) \
-          if self._config.useRPC else Login(callback, pilotID, password)
+          LoginRPC(self._rpcClient, callback, pilotID, password, entranceExam) \
+          if self._config.useRPC and not entranceExam \
+          else Login(callback, pilotID, password, entranceExam)
 
         self._addRequest(request)
-
-    def getEntryExamStatus(self, callback):
-        """Get the entry exam status."""
-        self._addRequest(GetEntryExamStatus(self._rpcClient, callback))
 
     def getFleet(self, callback):
@@ -1292,9 +1185,4 @@
         self._addRequest(SendBugReport(callback, summary, description, email))
 
-    def setCheckFlightPassed(self, callback, aircraftType):
-        """Mark the check flight as passed."""
-        self._addRequest(SetCheckFlightPassed(self._rpcClient,
-                                              callback, aircraftType))
-
     def run(self):
         """Process the requests."""
